using System;
using System.Collections.Generic;
using System.Text;

using System.Data;
using System.Data.SqlClient;
using OOP.Bank.Common;
using OOP.Bank.Interface;
using OOP.Bank.DataAccess;

namespace OOP.Bank.Business
{
    public class Customer : ICustomer
    {
        private Int32 _customer_uid;
        private String _firstname;
        private String _lastname;
        private String _email;
        private DateTime _date_created;
        private String _password;
        private IBankAccount _bank_account;

        public Customer()
        {
        }

        public Customer(String AccountNo)
        {
            SqlDataReader customer;
            customer = CustomerDac.Retrieve(AccountNo);

            if (customer.Read())
            {
                _customer_uid = Convert.ToInt32(customer["_customer_uid"]);
                _firstname = Convert.ToString(customer["_firstname"]);
                _lastname = Convert.ToString(customer["_lastname"]);
                _email = Convert.ToString(customer["_email"]);
                _date_created = Convert.ToDateTime(customer["_date_created"]);

                Account account = new Account(AccountNo);
                _bank_account = (IBankAccount)account;
            }
            customer.Close();
        }

        public Int32 CustomerID
        {
            get { return _customer_uid; }
            set { _customer_uid = value; }
        }

        public String FirstName
        {
            get { return _firstname; }
            set { _firstname = value; }
        }

        public String LastName
        {
            get { return _lastname; }
            set { _lastname = value; }
        }

        public String Email
        {
            get { return _email; }
            set { _email = value; }
        }

        public DateTime DateCreated
        {
            get { return _date_created; }
            set { _date_created = value; }
        }

        public String Password
        {
            get { return _password; }
            set { _password = value; }
        }

        public IBankAccount BankAccount
        {
            get { return _bank_account; }
            set { _bank_account = value; }
        }


        public String Create()
        {
            return CustomerDac.Create(this);
        }

        public Int32 Delete()
        {
            return CustomerDac.Delete(this);
        }

        public Int32 Update()
        {
            return CustomerDac.Update(this);
        }

        public Boolean Login(String AccountNo, String Password)
        {
            if (CustomerDac.Login(AccountNo, Password) > 0)
                return true;
            else
                return false;
        }
    }
}
