using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using OOP.Bank.Business;

public partial class CreateAccount : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected Boolean AllowSubmit()
    {
        if (txtFirstName.Text.Length <= 0)
            return false;
        if (txtLastName.Text.Length <= 0)
            return false;
        if (txtAccountBalance.Text.Length <= 0)
            return false;
        if (txtPassword.Text.Length <= 0)
            return false;

        return true;
    }

    protected void btnSubmit_Click(object sender, EventArgs e)
    {
        if (AllowSubmit())
        {
            Account account = new Account();
            Double InitialDeposit = Convert.ToDouble(txtAccountBalance.Text);

            if (InitialDeposit >= account.MaintainingBalance)
            {
                try
                {
                    Customer customer = new Customer();
                    customer.FirstName = txtFirstName.Text;
                    customer.LastName = txtLastName.Text;
                    customer.Email = txtEmail.Text;
                    customer.Password = FormsAuthentication.HashPasswordForStoringInConfigFile(txtPassword.Text, "SHA1");
                    String AccountNo = customer.Create();

                    Session["AccountNo"] = AccountNo;

                    account = new Account();
                    account.AccountNo = AccountNo;
                    account.AccountBalance = Convert.ToDouble(txtAccountBalance.Text);
                    account.Create();

                    Transaction transaction = new Transaction();
                    transaction.AccountNo = AccountNo;
                    transaction.Operation = "Initial Deposit";
                    transaction.Amount = InitialDeposit;
                    transaction.Create();

                    lblStatusMessage.Text = "Successfully created bank account!";
                    lblStatusMessage.Text += Environment.NewLine + "Your Account No is " + AccountNo;
                    litMessage.Text="<a href='Default.aspx'>Click here to to transact...</a>";
                }
                catch
                {
                    lblStatusMessage.Text = "Error in creating an account!";
                }
            }
            else
            {
                lblStatusMessage.Text = "The initial deposit must not be less than " + Convert.ToString(account.MaintainingBalance);
            }
        }
        else
        {
            lblStatusMessage.Text = "Please fill-up the required fields!";
        }
    }

    protected void btnCancel_Click(object sender, EventArgs e)
    {
        Response.Redirect("Login.aspx");
    }
}
